Subject: Re: bug#79267: cp --sparse=auto heuristic fails on a squashfs mounted drive.

From: Phillip Lougher <[email-masked]>
Date: Sat, 23 Aug 2025 19:46:05 +0100

On 23/08/2025 17:46, Paul Eggert wrote:
> On 2025-08-22 19:11, Phillip Lougher wrote:
>> any Squashfs SEEK_HOLE/SEEK_DATA implementation will not
>> behave like other Linux filesystems, because it won't report sparseness
>> at the 4K granularity that most people or programs will expect it to.
>
> Coreutils doesn't expect 4 KiB granularity for LSEEK_DATA+LSEEK_HOLE, 
> and I don't know of any programs that do expect it. I fail to see why 
> squashfs should penalize the performance of core programs like 'cp' 
> merely because some (which?) programs are poorly written.

As far as Squashfs is concerned SEEK_HOLE/SEEK_DATA is easy to 
implement.  So I'll think about adding it as a build option.

But this isn't going to fix it for any other case.

Phillip